## fcron-3.4.0-1.src.tar.gz

=== tests/Makefile ===

SRCDIR		:= .
# Useful to build packages
# you may want to use this var with a : 'make DESTDIR=dir install'
DESTDIR		:=

OPTIM		:= -DDEBUG -DCHECKRUNJOB -g -Wall -DFOREGROUND -DMALLOC_CHECK_=2 -Wpointer-arith -Wstrict-prototypes -I/usr/include/selinux
LDFLAGS		:= 
CPPFLAGS	:=  -I. -I${SRCDIR}
LIBS		:= -lpam  -lreadline -lcrypt -laudit -lselinux
LIBOBJS		:= 
DEFS		:= -DHAVE_CONFIG_H 
CC		:= gcc

CFLAGS += $(OPTIM) $(OPTION) $(DEFS) $(CPPFLAGS) $(LDFLAGS)

OBJSTEST := fcrondyn_svr_test.o $(LIBOBJS)

# this is a regular expression :
# do not ci automaticaly generated files and doc (done by doc's Makefile)
RCSNOCI:=.*\(.html\|VERSION\|MANIFEST\|configure\|install.sh\|config.log\|config.status\|config.h\|config.cache\|Makefile\|doc.*\|CVS.*\|.git.*\)

all: $(OBJSTEST)

%.o: %.c 
	$(CC) $(CFLAGS) -c $< -Wno-implicit-function-declaration -Wno-unused-variable

clean:
	rm -f *.o core

indent:
	indent -linux -i4 --no-tabs --leave-optional-blank-lines \
            --start-left-side-of-comments --procnames-start-lines \
            --dont-cuddle-else *.c *.h

=== PKGBUILD ===
# Contributor: Giorgio Lando <lando at imap dot cc>
# Contributor: Sergej Pupykin
# Contributor: Thomas Bächler
# Contributor: Sébastien Luttringer
# Maintainer: Thorsten Töpper <atsutane-tu@freethoughts.de>

pkgname=fcron
pkgver=3.4.0
pkgrel=1
pkgdesc='Feature-rich cron implementation'
arch=(x86_64)
url='http://fcron.free.fr'
license=('GPL')
depends=('pam' 'run-parts')
makedepends=('smtp-forwarder' 'vim' 'fcron' 'systemd')
# use fcron as recursive deps to have user fcron installed during installation
# else add the following in build chroot
# groupadd -g 23 fcron
# useradd -r -d /var/spool/fcron -u 23 -g 23 fcron
optdepends=('smtp-forwarder: to send mails from cron jobs'
            'vim: default editor for fcrontab')
provides=('cron')
conflicts=('dcron')
backup=('etc/fcron/fcron.conf'
        'etc/fcron/fcron.allow'
        'etc/fcron/fcron.deny'
        'var/spool/fcron/systab.orig')
options=('emptydirs' '!makeflags')
install=$pkgname.install
source=("http://fcron.free.fr/archives/$pkgname-$pkgver.src.tar.gz"
        "http://fcron.free.fr/archives/$pkgname-$pkgver.src.tar.gz.sign"
        "fcron.sysusers"
        'systab.orig')
sha512sums=('1ce4cf2f72ac66bfc97ec28d8d3b8c53f44cff4307b80cda86419db6a1d9c3ed288d5ce92f4af8e497f775c975ee9e1b7d6cbb4ae07e84df4fe64fbdeb3a3558'
            'SKIP'
            '91a373073015b44839c85e180a5721eaf49717e5dcfca862ab6d857fa70f05a7bacfa7709553db94c8ab5e30fb7e9431a97103bfe927ef326c3bcdbfa6f3ee28'
            '5ed83bcba95f28bceb716ccbc735284d7317f18d99506959abb24fa0f4a846435e23b4ab88ed64f71b89c89b1b02b182f708c3418a6095135ed75b9bb0ef446e')
validpgpkeys=('7733B98B987784DF27707D41F8E544EC485EE7BC')

build() {
  cd $pkgname-$pkgver
  # Don't use --username=root and --groupname=root, this completly break
  # fcron security and allow local root escalation.
  # Thanks to Anh K. Huynh <kyanh@theslinux.org> for reporting it.
  ./configure --prefix=/usr \
              --sbindir=/usr/bin \
              --sysconfdir=/etc/fcron \
              --with-answer-all=no \
              --with-boot-install=no \
              --datarootdir=/usr/share \
              --datadir=/usr/share \
              --with-docdir=/usr/share/doc \
              --localstatedir=/var \
              --with-systemdsystemunitdir=/usr/lib/systemd/system \
              --with-piddir=/run \
              --with-editor=/usr/bin/vim \
              --with-sendmail=/usr/bin/sendmail
  make
}

package() {
  cd $pkgname-$pkgver
  sed -e '/systemctl daemon-reload/d' -i Makefile
  make DESTDIR="$pkgdir/" install
  install -Dm644 files/fcron.pam "$pkgdir/etc/pam.d/fcron"
  install -Dm644 files/fcrontab.pam "$pkgdir/etc/pam.d/fcrontab"
  install -Dm644 "$srcdir/fcron.sysusers" "$pkgdir/usr/lib/sysusers.d/fcron.conf"

  # Install a default fcrontab so that fcron can completely replace dcron
  # We don't use binary format which is incompatible between arch and may cause crash
  # We regenerate the binary format at each update
  install -Dm640 "$srcdir/systab.orig" "$pkgdir/var/spool/fcron/systab.orig"

  # Add cron.* directories
  install -d -m755 "$pkgdir/etc/cron.daily"
  install -d -m755 "$pkgdir/etc/cron.hourly"
  install -d -m755 "$pkgdir/etc/cron.monthly"
  install -d -m755 "$pkgdir/etc/cron.weekly"

  # remove docs
  rm -r "$pkgdir/usr/share/doc"

  # avoid conflict with filesystem>=2012.06
  rmdir "$pkgdir"/{var/,}run

  # avoid conflict with libbsd - #31259
  rm "$pkgdir/usr/share/man/man3/bitstring.3" \
    "$pkgdir/usr/share/man/fr/man3/bitstring.3"
  rmdir --ignore-fail-on-non-empty "$pkgdir/usr/share/man/man3" \
    "$pkgdir/usr/share/man/fr/man3"
}

# vim:set ts=2 sw=2 et:

=== debian/control ===
Source: fcron
Section: admin
Priority: extra
Maintainer: Russell Coker <russell@coker.com.au>
Build-Depends: debhelper (>= 4.1.16), libpam0g-dev, libselinux1-dev (>= 1.2-1.1)
Standards-Version: 3.5.9

Package: fcron
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, debconf, system-log-daemon, mail-transport-agent, adduser (>=3.25), dpkg (>>1.8.3)
Conflicts: anacron, suidmanager (<< 0.50)
Description: cron-like scheduler with extended capabilities
 Fcron is a scheduler. It implements most of Vixie Cron's functionalities. 
 But contrary to Vixie Cron, fcron does not need your system to be up 7 days 
 a week, 24 hours a day: it also works well with systems which are running 
 neither all the time nor regularly.
 .
 Fcron also includes a useful system of options, such as: run jobs one by
 one, run jobs at fcron's startup if they should have been run during system
 down time, a better management of the mailing of outputs, set a nice value
 for a job...

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
# Modified for package fcron

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

# Enable debug package build if DEB_BUILD_OPTIONS contains debug
CONFFLAGS =
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CONFFLAGS += --with-debug
endif

configure-stamp: configure
	dh_testdir
	./configure --prefix=/usr --with-mandir=/usr/share/man --with-docdir=/usr/share/doc --with-editor=/usr/bin/sensible-editor --with-spooldir=/var/spool/fcron --with-etcdir=/etc --with-sendmail=/usr/sbin/sendmail $(CONFFLAGS) --with-selinux=yes

	touch configure-stamp

configure:
	autoconf

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	$(MAKE)
	touch build-stamp

clean:	configure
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	-$(MAKE) clean
	-$(RM) -f config.cache config.log config.status config.h Makefile

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	#$(MAKE) install prefix=`pwd`/debian/tmp/usr

	install -m 755 fcron `pwd`/debian/fcron/usr/sbin
	install -m 755 fcrontab fcronsighup fcrondyn `pwd`/debian/fcron/usr/bin
	install files/fcron.deny files/fcron.allow `pwd`/debian/fcron/etc
	install files/fcron.conf `pwd`/debian/fcron/etc
	install -m 644 files/fcrontab.pam `pwd`/debian/fcron/etc/pam.d/fcrontab
	install -m 644 files/fcron.pam `pwd`/debian/fcron/etc/pam.d/fcron

	install -m 755 debian/fcron-update-crontabs `pwd`/debian/fcron/usr/sbin

	# root's default crontab
	install -m 640 debian/crontab.root `pwd`/debian/fcron/var/spool/fcron/systab.orig

	# lintian overrides
	install -D -m 644 debian/lintian `pwd`/debian/fcron/usr/share/lintian/overrides/fcron

	# add anacron hack
	ln -s /bin/true `pwd`/debian/fcron/usr/sbin/anacron

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_installdebconf	
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installpam
	dh_installinit -- defaults 89 11
#	dh_installcron
	dh_installmanpages bitstring.3
#	dh_installinfo
	dh_installchangelogs
	dh_link
ifeq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	dh_strip
endif
	dh_compress
	dh_fixperms
	chmod 640 `pwd`/debian/fcron/etc/fcron.allow `pwd`/debian/fcron/etc/fcron.deny
	chmod 640 `pwd`/debian/fcron/etc/fcron.conf
	chmod 770 `pwd`/debian/fcron/var/spool/fcron
	#dh_suidregister
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
